AOMedia AV1 Codec: WinnerModeParams Struct Reference

| AOMedia AV1 Codec

Data Fields
WinnerModeParams Struct Reference

Parameters used for winner mode processing. More...

`#include <encoder.h>`

## Data Fields
unsigned int | coeff_opt_thresholds [MODE_EVAL_TYPES][2]
TX_SIZE_SEARCH_METHOD | tx_size_search_methods [MODE_EVAL_TYPES]
unsigned int | use_transform_domain_distortion [MODE_EVAL_TYPES]
unsigned int | tx_domain_dist_threshold [MODE_EVAL_TYPES]
unsigned int | skip_txfm_level [MODE_EVAL_TYPES]
unsigned int | predict_dc_level [MODE_EVAL_TYPES]

## Detailed Description

Parameters used for winner mode processing.

This is a basic two pass approach: in the first pass, we reduce the number of transform searches based on some thresholds during the rdopt process to find the "winner mode". In the second pass, we perform a more through tx search on the winner mode. There are some arrays in the struct, and their indices are used in the following manner: Index 0: Default mode evaluation, Winner mode processing is not applicable (Eg : IntraBc). Index 1: Mode evaluation. Index 2: Winner mode evaluation Index 1 and 2 are only used when the respective speed feature is on.

## Field Documentation

## ◆ coeff_opt_thresholds

unsigned int WinnerModeParams::coeff_opt_thresholds[MODE_EVAL_TYPES][2]

Threshold to determine if trellis optimization is to be enabled based on : 0 : dist threshold 1 : satd threshold Corresponds to enable_winner_mode_for_coeff_opt speed feature.

## ◆ tx_size_search_methods

TX_SIZE_SEARCH_METHOD WinnerModeParams::tx_size_search_methods[MODE_EVAL_TYPES]

Determines the tx size search method during rdopt. Corresponds to enable_winner_mode_for_tx_size_srch speed feature.

Referenced by encode_frame_internal().

## ◆ use_transform_domain_distortion

unsigned int WinnerModeParams::use_transform_domain_distortion[MODE_EVAL_TYPES]

Controls how often we should approximate prediction error with tx coefficients. If it's 0, then never. If 1, then it's during the tx_type search only. If 2, then always. Corresponds to tx_domain_dist_level speed feature.

## ◆ tx_domain_dist_threshold

unsigned int WinnerModeParams::tx_domain_dist_threshold[MODE_EVAL_TYPES]

Threshold to approximate pixel domain distortion with transform domain distortion. This is only used if use_txform_domain_distortion is on. Corresponds to enable_winner_mode_for_use_tx_domain_dist speed feature.

## ◆ skip_txfm_level

unsigned int WinnerModeParams::skip_txfm_level[MODE_EVAL_TYPES]

Controls how often we should try to skip the transform process based on result from dct. Corresponds to use_skip_flag_prediction speed feature.

## ◆ predict_dc_level

unsigned int WinnerModeParams::predict_dc_level[MODE_EVAL_TYPES]

Predict DC only txfm blocks for default, mode and winner mode evaluation. Index 0: Default mode evaluation, Winner mode processing is not applicable. Index 1: Mode evaluation, Index 2: Winner mode evaluation

The documentation for this struct was generated from the following file:

- av1/encoder/encoder.h